<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'add'
  }
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const formSchema = reactive<FormSchema[]>([
  {
    field: 'crtid',
    label: '主键',
    component: 'Input',
    hidden: true
  },{
    field: 'indexsetCode',
    label: '指标集编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'targetCode',
    label: '栏编码',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'beginDate',
    label: '开始日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'endDate',
    label: '结束日期',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'targetName',
    label: '栏名称',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'targetOrder',
    label: '排序',
    component: 'Input',
    componentProps: {
      
    },
  },
  {
    field: 'status',
    label: '状态',
    component: 'Select',
    componentProps: {
      
    },
  },
  {
    field: 'isOrgCollect',
    label: '是否机构汇总',
    component: 'Select',
    componentProps: {
      
    },
  }
])

const rules = reactive({
  
})

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

